<!doctype html>
<html lang="en">

	<head>
		<meta charset="utf-8">

			<title>Regular Expressions </title>

			<meta name="description" content="Regular Expressions (Search)">
		<meta name="author" content="José Calvo Tello">

		<meta name="apple-mobile-web-app-capable" content="yes">
		<meta name="apple-mobile-web-app-status-bar-style" content="black-translucent">

		<meta name="viewport" content="width=device-width, initial-scale=1.0">

		<link rel="stylesheet" href="../../lib/reveal/dist/reset.css">
		<link rel="stylesheet" href="../../lib/reveal/dist/reveal.css">
		<link rel="stylesheet" href="../../lib/reveal/dist/theme/white.css" id="theme">
		<link rel="stylesheet" href="custom.css">

		<!-- Theme used for syntax highlighting of code -->
		<link rel="stylesheet" href="../../lib/reveal/plugin/highlight/monokai.css" id="highlight-theme">
	</head>

	<body>

        <div class="reveal">
            <div class="slides">
              
				<section data-markdown="" data-separator="^\n---\n" data-separator-vertical="^\n--\n" data-charset="utf-8">
					<script type="text/template">
<!-- .slide: class="firstSlide" -->			
## 4. Regular Expressions

<br />

###### Library Carpentries workshop für subject specialists, SUB Göttingen, 28.02.2022

<hr />

##### Dr. José Calvo Tello
###### Niedersächsische Staats- und Universitätsbibliothek (SUB) Göttingen 

<hr />


<!--https://jose.calvotello.pages.gwdg.de/slides/talks/20201117_DH_Romanistik/-->

<img data-src="./img/regular expressions_target_sub_replicate-prediction-xxrrls6amvhovgdvjti7thquwu.png" width="300"/>


<br />
<img data-src="./../../images/GAU_SUB_horizontal_cmyk.jpg" width="500"/>



---

# 4. Regular Expressions (Search)

--

# Search

* Search for patterns in digital programs and documents
* Ctr + F
* GUK, Beispiel:
	* tit französisch?
	* tit digitale  geisteswissenschaften vs. digital? geisteswissenschaft?
* Many enviroments show slight differences

--

# Regular expressions are

* A regular expression is a method of using a sequence of characters to define a search to match strings
* regular expression or **regex**
* a concept and an implementation
* in many different programming environments
* sophisticated pattern matching 
* incredibly powerful
* find, manage, and transform data and files

--

## Regular expressions are also a super power

* Source: XKCD https://xkcd.com/208/
<br />

<img data-src="./img/regular_expressions.png" width="500"/>

--

# Data
* Basisklassifikation (BK) as plaintext
* bk.txt
* https://www.gbv.de/bibliotheken/verbundbibliotheken/02Verbund/01Erschliessung/02Richtlinien/05Basisklassifikation/index


--

## Notepad++
* Ctr + F
* Tabs: **Find**, **Replace**, Find in Files, Find Projects, Mark
* Options
	* "Match case" **unselected**
	* "Wrap around" **selected**
	* "Regular expression" **selected**
	* "Matches newlines" **unselected**
* Actions
	* Find Next
	* Count
	* Find All in Current Document
* Ctr + Z: **undo!**
* RegEx Pal for backup: https://www.regexpal.com/

--

### Exercise (without Regex)
* In BK search for the word "Garten"
* In BK search for the word "Wort" 

--

# Metacharacters

- **.** matches any character: "W.rt" finds Wirt, wart, Würt, Wort (Wbrt, W$rt, W2rt, W rt too...)
- **[]** matches the characters within []: "W[oe]rt" finds Wort and Wert (and wert)
- **\d** matches any single digit: 0, 1, 2, 3, 4, 5, 6, 7, 8, 9
- **\D** matches any single character that is NOT a digit
- **\w** matches any part of word character (any alphanumeric character)
- **\W** matches any part that is NOT word character (,;| _?...)
- **\s** matches any space, tab, or newline
	- **\n** matches only new line
	- **\t** matches only tabulator

--

### Metacharacters

- **.** matches any character
- **[]** matches the characters within []: "W[oe]rt" finds Wort and Wert
- **\d** matches any single digit
- **\w** matches any alphanumeric character
- **\s** matches any space, tab, or newline

### Exercise
* Find BK classes with "Garten" or "Gärten" <!--G[aä]rten-->
* Find BK classes with "Museum" or "Museen" <!--Muse[eu][nm]-->
* Find BK classes only with "Garten" or "Gärten" at the end of some word (i.e. Kindergarten) <!--\wg[aä]rten-->
* Find BK classes that start with "Technik" (for example, "50.00 Technik allgemein: Allgemeines") <!--\d\d;\sTechnik-->

--

# Backslash

* When we want to search for the actual character and not using it as metacharacter
* **\**
* To escape the metacharacter
* Examples:
	* \\.
	* \\[
	* \\-
	* \\*
	* \\?

## Exercise
* Search for classes with "7." (for example, "27.10") and not for clases such as "70.00", "18.70" or "18.07"
<!--\d7\.\d\d-->

--

# Character ranges

* When using **-** within **[]**, we can cover ranges of characters
* Examples
	* **[a-z]** matches the same as [abcdefghijklmnopqrstuvwxyz]
	* **[A-Za-z]**	 
	* **[0-9]** matches the same as [0123456789] which also matches the same as \d
	* **[a-zA-Z0-9]** matches the same as = \w

## Exercises
* BK Klassen für germanische Sprachen (from 18.00 to 18.19) <!--18\.[0-1]\d-->
* BK Klassen für Literaturwissenschaft (from 17.70 to 17.99) <!--17\.[7-9]\d-->
<!--* GOK-Klassen Textausgaben von allen germanischen Sprachen	 <!--H[R-W]\w 610-->

--

# Flags

* Match case
* . matches newline

### Exercise	
Find "garten" and not "Garten"

--

# Quantifiers
* **?** matches when the preceding character appears zero or one time. Example: For example, ab?c matches “ac” and “abc”. 
* **\*** matches the preceding element zero or more times. For example, ab\*c matches “ac”, “abc”, “abbbc”, etc. (further option: "\*?" = zero or more, not greedy)
* **+** matches the preceding element one or more times. For example, ab\+c matches “abc”, “abbbc” but not “ac”. (further option: "+?"  = one or more, not greedy)
* **{VALUE}** matches the preceding character the number of times define by VALUE. For example, a{3} matches “aaa” but not “aa”; ranges can be specified with the syntax {VALUE,VALUE}
* **|** means 'or'. For example, ab|ac matches “ab” and “ac” 

--

# Quantifiers
* **?** = 0 or 1
* **\*** = 0 or more 
* **+** = 1 or more
* **{VALUE}** = VALUE 
* **|** = 'or'.

## Exercise
* Search for "Wort", "Worte" or "Wörter" <!--W[oö]rte?r?-->
* Search for "Wörter" or "Woerter" using [] and a quantifier<!--W[oeö]+rter-->
* Search for "Garten" or "Gärten" using | <!--Garten|Gärten-->

--


# Anchors

- **`^`** asserts the position at the start of the line. So what you put after it will only match if they are the first characters of a line.
- **`$`** asserts the position at the end of the line. So what you put before it will only match if they are the last characters of a line.
- **`\b`** adds a word boundary. Putting this either side of a word stops the regular expression matching longer variants of words. So:
- Examples:
	* the regular expression foobar will match foobar and find 666foobar, foobar777, 8thfoobar8th et cetera
    * the regular expression \bfoobar will match foobar and find foobar777
    * the regular expression foobar\b will match foobar and find 666foobar
    * the regular expression \bfoobar\b will find foobar

--

# Anchors

- **`^`** = the start of the line
- **`$`** = the end of the line
- **`\b`** = word boundary

## Exercises
* Search for a class that DOES NOT start with a number
* Search for classs starting with 17
* Find words with "Garten" or "Gärten" at the beginning (ex. Gartenkunst)
* Find words with "Garten" or "Gärten" at the end (ex. Kindergarten)
* Search for the words "Garten" or "Gärten" as independent words

--

# Congrats, now you have super powers!

<img data-src="./img/regular_expressions_3.png" width="500"/>


---


# 5. Regular Expressions (Replace)

--

# Data

* Selected_Niederdeutsch.xlsx
* Column "Verfasser"
	* Example: Blesken, Andreas Heinrich *1874-1959* ; ID: gnd/120987228
* Column "Ort+Verlag"
	* Example: Dortmund : Lensing
* We want these informations in other format
* Do we change the hundreds of cases one by one by hand?

--

# No, now you can regex!

<img data-src="./img/regular_expressions_3.png" width="500"/>

--

# Replace
* Ctr + H in Notepad++
* Search / Replace
	* Find what
	* Replace with

--

# Replacing literals
* Copy the column "Ort+Verlag" to Notepad++
* Change this:
	* Dortmund : Lensing
* To this:
	* Dortmund ; Lensing
* No need of regex!
* Replace ":" with ";"

--

# But what if
* We want to change:
	* Dortmund : Lensing
* To this?:
	* Lensing, Dortmund

--

# Grouping

* With () we can create groups. Example (W[oe]rt)
* This groups can be used for replacing text, using \1, \2, \3, etc.

--

# Example with "Ort+Verlag"
* We want to change "Dortmund : Lensing" with "Dortmund, Lensing" in all cases and use a regular expression for that
* Find what: ^(.+) : (.+)$
* Replace with: \1, \2

--

# Exercise with "Ort+Verlag"
* Change "Dortmund : Lensing" with "In Dortmund, by Lensing" in all cases
<!--* Find what: "^(.+) : (.+)$"-->
<!--* Replace with: "In \1, by \2"-->

--

# Example with "Ort+Verlag"
* We want to change "Dortmund : Lensing" with "Lensing, Dortmund" in all cases
* Find what: ^(.+) : (.+)$
* Replace with: \2, \1

--

# Exercise with "Ort+Verlag"
* We want to change "Dortmund : Lensing" with "By Lensing, in Dortmund" in all cases
<!--* Find what: ^(.+) : (.+)$--
<!--* Replace with: "In \2, by \1"-->


--

## Example: Getting a column only for place

* Get only the place
* Find what: ^(.+) : (.+)$
	* Also possible: ^(.+) : .+$
* Replace with: \1
* Copy again to the Excel file as new column

--

## Exercise
* Copy the column "Ort+Verlag" to Notepad++
* Get only the publisher
* Copy the data back to the Excel file as a new (tidy) column 

<!--
* Find what: ^(.+) : (.+)$
* Replace with: \2
-->


--

## Example
* Get the column "Verfasser" to Notepad++
* Get only the surnane
* Find what: ^(.+),.+$
* Replace with: \1
* Copy again to the Excel file as new column

--

## Exercise
* Get the column "Verfasser" to Notepad++
* Get only the first name
* Copy again to the Excel file as new column


--

## Exercises
* Do the same with:
	* The year of birth <!-- 	^.+\*(\d\d\d\d).+$		\1				-->
	* The year of death <!--	^.+\-(\d\d\d\d)\*.+$	\1	-->
	* The GND-Id (without the "gnd/") <!--	^.+gnd\/(\w+)		\1-->

--

## Exercise
* Make a single search and replace that change this:
	* "Blesken, Andreas Heinrich \*1874-1959\* ; ID: gnd/120987228"
* to this:
	* "Andreas Heinrich Blesken (GND-ID = 120987228). Born in 1874, dead in 1959.
<!--	^(.+), (.+) \*(\d\d\d\d)\-(\d\d\d\d)\* ; ID: gnd\/(\w+)$-->
<!--	\2 \1 \(GND-ID = \5\). Born in \3, dead in \4-->

--

## Answer
* Find what: ^(.+), (.+) \\\*(\d\d\d\d)\\-(\d\d\d\d)\\\* ; ID: gnd\\/(\w+)$
* Replace with: \2 \1 \\(GND-ID = \5\\). Born in \3, dead in \4


---




# Now go and regex the world!

<img data-src="./img/regular_expressions_3.png" width="500"/>

## Danke für die Aufmerksamkeit!

--

				
					</script>
				</section>
            </div>
        </div>

        <script src="../../lib/reveal/dist/reveal.js"></script>
        <script src="../../lib/reveal/plugin/zoom/zoom.js"></script>
        <script src="../../lib/reveal/plugin/notes/notes.js"></script>
        <script src="../../lib/reveal/plugin/search/search.js"></script>
        <script src="../../lib/reveal/plugin/markdown/markdown.js"></script>
        <script src="../../lib/reveal/plugin/highlight/highlight.js"></script>
        <script>
    
          // Also available as an ES module, see:
          // https://revealjs.com/initialization/
          Reveal.initialize({
            controls: true,
            progress: true,
            center: true,
            hash: true,
    
            // Learn about plugins: https://revealjs.com/plugins/
            plugins: [ RevealZoom, RevealNotes, RevealSearch, RevealMarkdown, RevealHighlight ]
          });
    
        </script>
    
      </body>
    </html>
    